///
///  example.cpp
///

#include <windows.h>
#include <Python.h>
#include <tsx.h>

int fibonacciImpl(int n)
{
  if (n < 2)
    return 1;
  else
    return fibonacciImpl(n - 1) + fibonacciImpl(n - 2);
}

PyObject *exampleFibonacci(PyObject *self, PyObject *args)
{
  int n = 10, result = 0;

  PyArg_ParseTuple(args, "i", &n);

  result = fibonacciImpl(n);

  return Py_BuildValue("i", result);
}

PyMethodDef exampleMethods[] =
  {
    {"fib", exampleFibonacci, METH_VARARGS},
    {NULL, NULL}
  };

__declspec(dllexport) void initExample()
{
  PyObject *module, *dictionary;

  module = Py_InitModule("Example", ::exampleMethods);
  dictionary = PyModule_GetDict(module);
}
